#include <epm/epm.h>
#include <string>
#include <map>
#include "epm_handler_common.h"
#include <tccore/aom.h>
#include <tccore/aom_prop.h>
#include "common_itk_util.h"
#include "tc_util.h"
#include <tc/preferences.h>
#include <fclasses\tc_date.h>
#include "CRUL_server_call_httpserver.h"
#include "ocilib.h"
#include "cJSON.h"
#include "tinyxml2.h"
using namespace std;
using namespace tinyxml2;



void connectSql() {
	int url_num = 0;
	char** url_vals = NULL;
	PREF_ask_char_values("database_tc", &url_num, &url_vals);
	string url = url_vals[0];
	url.append("/").append(url_vals[2]);
	printf("url ==> %s \n", url.c_str());
	if (ConnServer(url_vals[3], url_vals[4], (char*)url.c_str()) == -1)
	{
		printf("ʾ:мݱʧ\n");
	}
}
void closeConn() {
	DisConnServer();
}

/*
	SRMӿ
*/
int CHINT_SendSRM(EPM_action_message_t msg) {
	int ifail = ITK_ok;
	tag_t root_task = NULLTAG, *sub_tasks = NULL, current_task = NULLTAG, type_tag = NULLTAG;
	int sub_task_count = 0, attachCounts = 0;
	tag_t* taskAttches = NULLTAG;
	tag_t cur_task = NULLTAG;
	current_task = msg.task;
	EPM_ask_root_task(msg.task, &root_task);
	EPM_ask_sub_tasks(root_task, &sub_task_count, &sub_tasks);
	EPM_ask_attachments(root_task, EPM_target_attachment, &attachCounts, &taskAttches);

	//̶ ZT2_Procure Revision 
	for (int i = 0; i < attachCounts; i++) {
		int pdfCnt = 0;
		char *objType, *wbsNo, *materialNo, *revisionId;
		tag_t procureRev = taskAttches[i], *datasets;
		AOM_ask_value_string(procureRev, OBJECTTYPE, &objType);
		if (strcmp(objType, PROCURETYPE) == 0) {
			//ȡ汾ԣwbsϱ롢汾ȡ淶ϵµpdfļȡļuidͨӿSRMϵͳ
			AOM_ask_value_string(procureRev, WBSNO, &wbsNo);
			AOM_ask_value_string(procureRev, MATERIALNO, &materialNo);
			AOM_ask_value_string(procureRev, REVISIONID, &revisionId);
			AOM_ask_value_tags(procureRev, SPECIFICATION, &pdfCnt, &datasets);
			//ȡݼƺUID
			
		}
	}

	return ifail;
}

cJSON* getDrawingInform(tag_t changeTag) {
	int changeNo, signNo, placesNo, beforeNo, verBefNo, aftNo, aftVerNo, reasonNo, processTypeNo, prodNct;
	char **changeDrawingNos, **signs, **placesNos, **changeBefs, **versionBefs,
		 **changeAfts, **versionAfts, **changeReasons, **processTypes, **products;
	AOM_ask_value_strings(changeTag, "zt2_ChangeDrawingNo",&changeNo, &changeDrawingNos);
	AOM_ask_value_strings(changeTag, "zt2_Sign", &signNo, &signs);
	AOM_ask_value_strings(changeTag, "zt2_PlacesNo", &placesNo, &placesNos);
	AOM_ask_value_strings(changeTag, "zt2_ChangeBefore1", &beforeNo, &changeBefs);
	AOM_ask_value_strings(changeTag, "zt2_SZVersionbefore", &verBefNo, &versionBefs);
	AOM_ask_value_strings(changeTag, "zt2_ChangeAfter1", &aftNo, &changeAfts);
	AOM_ask_value_strings(changeTag, "zt2_SZRevisedversion", &aftVerNo, &versionAfts);
	AOM_ask_value_strings(changeTag, PROP_PRODUCT, &prodNct, &products);
	AOM_ask_value_strings(changeTag, "zt2_ChangeReason", &reasonNo, &changeReasons);
	AOM_ask_value_strings(changeTag, "zt2_ProcessType1", &processTypeNo, &processTypes);
	cJSON* infomations = cJSON_CreateArray();
	for (int i = 0; i < changeNo; i++) {
		cJSON* infomation = cJSON_CreateObject();
		cJSON_AddStringToObject(infomation, "S_DrawingCode", changeDrawingNos[i]);
		cJSON_AddStringToObject(infomation, "S_Sign", signNo > i ? signs[i] : "");
		cJSON_AddStringToObject(infomation, "S_CS", placesNo > i ? placesNos[i] : "");
		cJSON_AddStringToObject(infomation, "S_PreChange", beforeNo > i ? changeBefs[i] : "");
		cJSON_AddStringToObject(infomation, "S_PreChangeVersion", verBefNo > i ? versionBefs[i] : "");
		cJSON_AddStringToObject(infomation, "S_AfterChange", aftNo > i ? changeAfts[i] : "");
		cJSON_AddStringToObject(infomation, "S_AfterChangeVersion", aftVerNo > i ? versionAfts[i] : "");
		cJSON_AddStringToObject(infomation, JSON_TXDJ, prodNct > i ? products[i] : "");
		cJSON_AddStringToObject(infomation, "S_ChangeReason", reasonNo > i ? changeReasons[i] : "");
		cJSON_AddStringToObject(infomation, "S_ZZPCL", processTypeNo > i ? processTypes[i] : "");
		cJSON_AddItemToArray(infomations, infomation);
	}
	return infomations;
}
cJSON* getEHDepart(string ecnCode,string section,string &uuid) {
	
	string searchSql = "SELECT \"actionstatement\",\"result\",\"pctime\",\"remark\",\"principal\" FROM CHINT_ECN_NOTIFICATION where \"ecncode\" = '%s' and \"section\" = '%s' order by \"no\"";
	char selectRecord2[400];
	sprintf(selectRecord2, searchSql.c_str(), ecnCode.c_str(), section);
	int outputColumn1 = 0, outputValueCount1 = 0;
	char*** outputValue1 = NULL;
	printf("selectRecord2 ===> %s\n", selectRecord2);
	QuerySQLNoInputParam(selectRecord2, &outputColumn1, &outputValueCount1, &outputValue1);
	cJSON* infomations = cJSON_CreateArray();
	for (int i = 0; i < outputValueCount1; i++) {
		cJSON* infomation = cJSON_CreateObject();
		if (i == 0) {
			vector<string> uuidVec;
			Split(outputValue1[i][4],";", uuidVec);
			if (uuidVec.size() > 1 && strstr(uuidVec[1].c_str(),"null") == NULL) {
				uuid = uuidVec[1];
			}
		}
		cJSON_AddStringToObject(infomation, "S_JSBaction", outputValue1[i][0]);
		cJSON_AddStringToObject(infomation, "S_PD", outputValue1[i][1]);
		cJSON_AddStringToObject(infomation, "T_PlanTime", outputValue1[i][2]);
		cJSON_AddStringToObject(infomation, "S_Remark", outputValue1[i][3]);
		cJSON_AddItemToArray(infomations, infomation);
	}
	return infomations;
}
//ϴļminio
string uploadMinio(string jarName, string logPath) {
	char cmd[256] = "";
	strcpy(cmd, "java -jar \"");
	//strcat(cmd, jar_file);
	strcat(cmd, getenv("TC_ROOT"));
	strcat(cmd, "\\bin\\");
	strcat(cmd, jarName.c_str());
	strcat(cmd, "\" ");
	string strResult;
	strcat(cmd, logPath.c_str());
	char buf[8000] = { 0 };
	printf("·:\n%s\n", cmd);
	FILE* pf = NULL;
	if ((pf = _popen(cmd, "r")) == NULL) {
		printf("ӿڷ:\n%s", "1");
	}
	while (fgets(buf, sizeof buf, pf)) {
		strResult += buf;
	}
	_pclose(pf);
	return strResult;
	//return;
}
/*
	ļ
*/
int file_xcopy_stod(const char* source_dir, const char* destination_dir)
{
	ifstream infile(source_dir, ios::in | ios::binary);//ʽ
	if (infile.is_open() == 0) {//
		cout << "ļ" << source_dir << "ʧ" << endl;
		return -1;
	}
	ofstream outfile(destination_dir, ios::out | ios::binary);//ʽ
	if (outfile.is_open() == 0) {//
		cout << "ļ" << destination_dir << "ʧ" << endl;
		infile.close();//ǵùر
		return -1;
	}
	//ʼд
	const int FLUSH_NUM = 1024 * 1024;//СΪ1M
	char* ch = new(nothrow)char[FLUSH_NUM];
	if (ch == NULL) {//
		cout << "̬ڴʧ" << endl;
		infile.close();//ǵùر
		outfile.close();//ǵùر
		return -1;
	}
	while (!infile.eof()) {
		infile.read(ch, FLUSH_NUM);
		outfile.write(ch, infile.gcount());//дĳɹ
	}
	delete[]ch;//ǵͷ
	infile.close();//ǵùر
	outfile.close();//ǵùر
	return 0;
}

//͵OA
int CHINT_ECN_SendOA(EPM_action_message_t msg) {

	int ifail = ITK_ok;
	ECHO("=========================================================\n");
	ECHO("CHINT_ECN_SendOA ʼִ\n");
	ECHO("=========================================================\n");
	tag_t root_task = NULLTAG, *sub_tasks = NULL, current_task = NULLTAG, type_tag = NULLTAG;
	int sub_task_count = 0, occur_of_counts = 0;
	tag_t* taskAttches = NULLTAG;
	tag_t cur_task = NULLTAG;
	char* jobName;
	current_task = msg.task;
	AOM_ask_value_string(current_task, "job_name", &jobName);
	EPM_ask_root_task(msg.task, &root_task);
	EPM_ask_sub_tasks(root_task, &sub_task_count, &sub_tasks);
	EPM_ask_attachments(root_task, EPM_target_attachment, &occur_of_counts, &taskAttches);
	//ȡurlַ
	char* url, *userId, *urlId;//
	PREF_ask_char_value("CHINT_ECNSendOAUrl", 0, &url);
	PREF_ask_char_value("CHINT_OAUserID_RUL", 0, &urlId);
	char* log_file = NULL;
	CreateLogFile("CHINT_ECN_SendOA", &log_file); //
	//ȡǰĿ
	connectSql();
	POM_get_user_id(&userId);
	string email = userId;
	email.append("@chint.com");
	string userXML = getUserIdOA(email, urlId);
	//ȡ½
	tag_t group;
	char *groupName, *taskUid;
	POM_ask_group(&groupName, &group);
	AOM_ask_value_string(group, PROP_GROUP_NAME, &groupName);
	string userCode = readXmlId(userXML);
	ITK__convert_tag_to_uid(msg.task, &taskUid); //uid
	for (int count = 0; count < occur_of_counts; count++) {
		char *type;
		tag_t taskTag = taskAttches[count];
		AOM_ask_value_string(taskTag, "object_type", &type);
		if (strcmp(type, "ZT2_Change") == 0) {
			//ȡ ѯݿдJSON
			int unitCnt, processCnt = 0;
			char* changeType, *productModel,
				*productName, *fileName, *contractNo, *contractName,
				*changeDateStr, **changeUnits, *itemId, *changeRequestNo, **processTypes;
			AOM_ask_value_string(taskTag, "item_id", &itemId);
			date_t changeDate;
			AOM_ask_value_string(taskTag, "zt2_ChangeType", &changeType);//
			AOM_ask_value_string(taskTag, "zt2_ProductModel", &productModel);//Ʒͺ
			AOM_ask_value_string(taskTag, "zt2_ProductName", &productName); // Ʒ
			AOM_ask_value_string(taskTag, "zt2_FileName", &fileName); // 	ļż
			AOM_ask_value_string(taskTag, "zt2_ContractNo", &contractNo); // ͬ
			AOM_ask_value_string(taskTag, "zt2_ContractName", &contractName); // ͬ
			AOM_ask_value_date(taskTag, "zt2_ChangeDate", &changeDate); // ʵʩ
			AOM_ask_value_strings(taskTag, "zt2_ChangeUnit1",&unitCnt, &changeUnits); // ͬ
			AOM_ask_value_string(taskTag, "zt2_ChangRequestNo", &changeRequestNo); // ֪ͨ
			AOM_ask_value_strings(taskTag, PROP_PROCESS, &processCnt, &processTypes);
			cJSON* paramValue = cJSON_CreateObject();
			//jsonֶ
			/*S_ProductFeature	Ʒ	ַ	A; B; C
				S_GCFeeature		ַ	A; B; C*/
			cJSON_AddStringToObject(paramValue, S_GCDM, groupName);//
			cJSON_AddStringToObject(paramValue, "S_ChangeCode", itemId);//뵥
			cJSON_AddStringToObject(paramValue, "S_PLMCode", taskUid);
			cJSON_AddStringToObject(paramValue, "S_ChangeNotificationCode", changeRequestNo);
			string productFeature, changeTypeStr;
			if (processCnt > 0) {
				char *type = processTypes[0];
				if (strcmp(type, "Y") == 0) {
					productFeature = S_Product;
				}
				else {
					productFeature = S_Process;
				}
			}
			if (strstr(changeType, S_ZSChange) != NULL) {
				changeTypeStr = S_ZSChange;
			}
			else {
				changeTypeStr = S_LSChange;
			}
			cJSON_AddStringToObject(paramValue, "S_ProductFeature", productFeature.c_str());
			cJSON_AddStringToObject(paramValue, "S_ChangeTypes", changeTypeStr.c_str());
			cJSON_AddStringToObject(paramValue, "S_ProductNumber", productModel);
			cJSON_AddStringToObject(paramValue, "S_ProductName", productName);
			cJSON_AddStringToObject(paramValue, "S_Pcodename", fileName);
			cJSON_AddStringToObject(paramValue, "S_Contractcode", contractNo);
			cJSON_AddStringToObject(paramValue, "S_ContractName", contractName);
			DATE_date_to_string(changeDate, "%Y-%m-%d", &changeDateStr);
			cJSON_AddStringToObject(paramValue, "T_MaterialDate", changeDateStr);
			cJSON_AddStringToObject(paramValue, "S_FFBM", changeUnits[0]);
			//EH_DrawingInformationͼϢ
			cJSON* infomations = getDrawingInform(taskTag);
			cJSON_AddItemToObject(paramValue, "EH_DrawingInformation", infomations);
			string jsbUUid = "", gybUUid = "", zlbUUid = "", 
				scbUUid = "", cgbUUid = "", xszxUUid = "", cwbUUid = "";
			cJSON* jsbZx = getEHDepart(itemId, "", jsbUUid);
			cJSON_AddItemToObject(paramValue, "EH_JSBZX", jsbZx);
			cJSON* gybZx = getEHDepart(itemId, "ղ", gybUUid);
			cJSON_AddItemToObject(paramValue, "EH_GYBZX", gybZx);
			cJSON* zlbZx = getEHDepart(itemId, "", zlbUUid);
			cJSON_AddItemToObject(paramValue, "EH_ZLBZX", zlbZx);
			cJSON* scbZx = getEHDepart(itemId, "", scbUUid);
			cJSON_AddItemToObject(paramValue, "EH_SCBZX", scbZx);
			cJSON* cgbZx = getEHDepart(itemId, "ɹ", cgbUUid);
			cJSON_AddItemToObject(paramValue, "EH_CGBZX", cgbZx);
			cJSON* saleCenter = getEHDepart(itemId, "", xszxUUid);
			cJSON_AddItemToObject(paramValue, "EH_XSZXZX", saleCenter);
			cJSON* cwbZx = getEHDepart(itemId, "", cwbUUid);
			cJSON_AddItemToObject(paramValue, "EH_CWBZX", cwbZx);
			cJSON_AddStringToObject(paramValue, "S_JSBZRR", jsbUUid.c_str());
			cJSON_AddStringToObject(paramValue, "S_GYBZRR", gybUUid.c_str());
			cJSON_AddStringToObject(paramValue, "S_ZLBZRR", zlbUUid.c_str());
			cJSON_AddStringToObject(paramValue, "S_SCBZRR", scbUUid.c_str());
			cJSON_AddStringToObject(paramValue, "S_CGBZRR", cgbUUid.c_str());
			cJSON_AddStringToObject(paramValue, "S_XSZXZRR", xszxUUid.c_str());
			cJSON_AddStringToObject(paramValue, "S_CWBZRR", cwbUUid.c_str());

			char *json_to_char = cJSON_Print(paramValue);
			string returnMsg = ecnSendOA(userCode.c_str(), json_to_char, url);
			WriteLog("֮֯JSON\n %s\n", json_to_char);
			WriteLog("شϢ\n %s\n", returnMsg.c_str());
			if (!returnMsg.empty()) {
				EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, returnMsg.c_str());
			}
		}
	
	}
	closeConn();
	CloseLog();
	//string str = uploadMinio("uploadMinio.jar", log_file);
	char date_string[MAX_PATH_LENGTHE], logFileName[MAX_PATH_LENGTHE];;
	time_t now;
	struct tm *p;
	time(&now);
	//current_time(&status_now);
	p = localtime(&now);
	memset(date_string, 0, sizeof(date_string));
	sprintf(date_string, "%4d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
	sprintf(logFileName, "%s\\%s_%s.log", LOG_PATH, taskUid, date_string);
	file_xcopy_stod(log_file, logFileName);
	//printf("str %s \n", str.c_str());
	return ifail;
}